Package: denvax
Type: Package
Title: Simple Dengue Test and Vaccinate Cost Thresholds
Version: 0.1.2
Authors@R: c(
    person("Carl A. B.", "Pearson", email="carl.pearson@lshtm.ac.uk", role = c("aut","cre"), comment = c(ORCID="0000-0003-0701-7860")),
    person("Kaja M.", "Abbas", role = c("aut"), comment = c(ORCID="0000-0003-0563-1576")),
    person("Samuel", "Clifford", role = c("aut"), comment = c(ORCID="0000-0002-3774-3882")),
    person("Stefan", "Flasche", role = c("aut"), comment = c(ORCID="0000-0002-5808-2606")),
    person("Thomas J.", "Hladish", role = c("aut"), comment = c(ORCID="0000-0003-1819-6235"))
  )
Description: Provides the mathematical model described by "Serostatus Testing & Dengue Vaccine Cost-Benefit Thresholds"
    in <doi:10.1098/rsif.2019.0234>.  Using the functions in the package,
    that analysis can be repeated using sample life histories, either synthesized from local seroprevalence data
    using other functions in this package (as in the manuscript) or from some other source.
    The package provides a vignette which walks through the analysis in the publication, as well as a function
    to generate a project skeleton for such an analysis.
License: MIT + file LICENSE
Encoding: UTF-8
LazyData: true
Depends: R (>= 3.5)
Suggests: data.table, testthat, usethis, devtools, roxygen2, jsonlite,
        ggplot2, cowplot, directlabels, rmarkdown, knitr
RoxygenNote: 6.1.1
VignetteBuilder: knitr
URL: https://gitlab.com/cabp_LSHTM/denvax
BugReports: https://gitlab.com/cabp_LSHTM/denvax/issues
NeedsCompilation: no
Packaged: 2019-11-30 20:31:28 UTC; carlpearson
Author: Carl A. B. Pearson [aut, cre] (<https://orcid.org/0000-0003-0701-7860>),
  Kaja M. Abbas [aut] (<https://orcid.org/0000-0003-0563-1576>),
  Samuel Clifford [aut] (<https://orcid.org/0000-0002-3774-3882>),
  Stefan Flasche [aut] (<https://orcid.org/0000-0002-5808-2606>),
  Thomas J. Hladish [aut] (<https://orcid.org/0000-0003-1819-6235>)
Maintainer: Carl A. B. Pearson <carl.pearson@lshtm.ac.uk>
Repository: CRAN
Date/Publication: 2019-12-01 19:00:02 UTC
Built: R 4.3.3; ; 2025-01-24 06:31:17 UTC; unix

Package: denvax
Type: Package
Title: Simple Dengue Test and Vaccinate Cost Thresholds
Version: 0.1.2
Authors@R: c(
    person("Carl A. B.", "Pearson", email="carl.pearson@lshtm.ac.uk", role = c("aut","cre"), comment = c(ORCID="0000-0003-0701-7860")),
    person("Kaja M.", "Abbas", role = c("aut"), comment = c(ORCID="0000-0003-0563-1576")),
    person("Samuel", "Clifford", role = c("aut"), comment = c(ORCID="0000-0002-3774-3882")),
    person("Stefan", "Flasche", role = c("aut"), comment = c(ORCID="0000-0002-5808-2606")),
    person("Thomas J.", "Hladish", role = c("aut"), comment = c(ORCID="0000-0003-1819-6235"))
  )
Description: Provides the mathematical model described by "Serostatus Testing & Dengue Vaccine Cost-Benefit Thresholds"
    in <doi:10.1098/rsif.2019.0234>.  Using the functions in the package,
    that analysis can be repeated using sample life histories, either synthesized from local seroprevalence data
    using other functions in this package (as in the manuscript) or from some other source.
    The package provides a vignette which walks through the analysis in the publication, as well as a function
    to generate a project skeleton for such an analysis.
License: MIT + file LICENSE
Encoding: UTF-8
LazyData: true
Depends: R (>= 3.5)
Suggests: data.table, testthat, usethis, devtools, roxygen2, jsonlite,
        ggplot2, cowplot, directlabels, rmarkdown, knitr
RoxygenNote: 6.1.1
VignetteBuilder: knitr
URL: https://gitlab.com/cabp_LSHTM/denvax
BugReports: https://gitlab.com/cabp_LSHTM/denvax/issues
NeedsCompilation: no
Packaged: 2019-11-30 20:31:28 UTC; carlpearson
Author: Carl A. B. Pearson [aut, cre] (<https://orcid.org/0000-0003-0701-7860>),
  Kaja M. Abbas [aut] (<https://orcid.org/0000-0003-0563-1576>),
  Samuel Clifford [aut] (<https://orcid.org/0000-0002-3774-3882>),
  Stefan Flasche [aut] (<https://orcid.org/0000-0002-5808-2606>),
  Thomas J. Hladish [aut] (<https://orcid.org/0000-0003-1819-6235>)
Maintainer: Carl A. B. Pearson <carl.pearson@lshtm.ac.uk>
Repository: CRAN
Date/Publication: 2019-12-01 19:00:02 UTC
Built: R 4.6.0; ; 2026-04-25 18:11:35 UTC; unix

# Project Template

The `denvax::build.project(...)` function creates a skeleton project your analysis.

The `Makefile` provides the relationships between the various single step scripts, and a way to run them as a workflow. Alternatively, they can be run manually from the command line or in an application like Rstudio.

The `simple.R` script demonstrates a simple start-to-finish analysis (using the Morrison 2010 data included in the package).

In either approach, the steps are:

1. develop fit(s) for local serological data (e.g., use the `fit.R` script in Rstudio, write your own script with the `denvax::serofit` function, or use make with the target `%-fit.json` in Makefile).
2. use a fit to synthesize a population (e.g., `synthesize.R` script, the `denvax::synthetic.pop` function, or the target `%-lh.rds` in Makefile)
3. use the synthetic population to estimate the lifetime outcome probabilities (e.g., `digest.R` script, the `denvax::npxa` function, or the target `%-npxa.rds` in Makefile)
4. combine the probabilities with the desired boundaries for interventions (initial testing age and maximum number of tests) and to compute the ROI equation coefficients (`denvax::ROIcoeffs` function)
5. finally, combine the coefficients with desired cost fraction ranges (i.e., the cost of vaccination and testing as fractions of the estimated burden of secondary infection, or $\nu$ and $\tau$ respectively), to determine the threshold region for positive ROI (`denvax::ROI` function).

The `pub/` folder includes all the scripts necessary to generate the figures associated with the original publication of the analysis.

suppressPackageStartupMessages({
  require(data.table)
  require(jsonlite)
  require(ggplot2)
  require(cowplot)
})

#' @example
#' .args <- c("results/fig-scales.rda", "results/scan-rois.rds", "results/scan-params.rds", "results/fig-scan.png")
.args <- commandArgs(trailingOnly = T)

# load pre-computed shared figure elements; e.g., scales, helper functions, labels
load(.args[1])

refpars <- readRDS(.args[3])[, seropos := 1 - seroneg9 ]

reducedrois <- readRDS(.args[2])[mechanism == "binary"][
  refpars, on = .(foi, disparity)
][, roi,
  by = .(foi, disparity, seropos, p_H, log10OR, nu, tau, A, L)
]

rename <- function(res, ref) { names(res) <- ref; return(res) }

foiref <- refpars[, seropos[1], by = .(ref = foi)][, rename(V1, ref)]
pHref <- refpars[, p_H[1], by = .(ref = disparity)][, rename(V1, ref)]
ORref <- refpars[, log10OR[1], by = .(ref = disparity)][, rename(V1, ref)]

disref <- list(
  md = quote(Disparity ~ (p[H] * ", " * log[10] * OR)),
  ll = quote(phantom("Disparity" ~ (p[H] * ", " * log[10] * OR))),
  ul = quote(phantom("Disparity" ~ (p[H] * ", " * log[10] * OR)))
)

plot.dt <- reducedrois[
  disparity == "ll" & foi == "ul" &
  (nu - 0.5) ^ 2 < 0.0001 &
  log10(tau) %in% seq(-2, -1, by = .5)
]

scale_start_age <- scale_x_continuous(
  "Initial Age for Routine Testing",
  breaks = 5:10,
  expand = expand_scale(add = 0.5)
)

scale_num_tests   <- scale_y_continuous(
  "Maximum # of Tests",
  breaks = function(lims) seq(round(lims[1]), round(lims[2]), by = 1),
  expand = expand_scale(add = 0.5)
)

p <- ggplot(plot.dt) + aes(
  A, L,
  fill = roi, z = roi, color = c("neg", "pos")[(roi > 0) + 1]
) + facet_grid(
  disparity + nu + foi ~ tau,
  labeller = label_bquote(
    rows = atop(
      nu * " = " * .(sprintf("%0.1f", nu)) * ", " * .(
        c(ll = "Low", md = "Mid", ul = "High")[disparity]
      ) * " Disparity",
      .(
        c(ll = 50, md = 70, ul = 90)[foi]
      ) * "% " * S ^ "+" * " in 9-year-olds"
    ),
    cols = tau * " = " * .(sprintf("%0.2f", tau))
  )
) +
  geom_heat +
  coord_cartesian(xlim = c(5, 10), ylim = c(1, 10)) +
  scale_num_tests + scale_start_age + scale_roi +
  scale_contour + thm + theme(
    panel.spacing.x = unit(12, "pt")
  )

save_plot(
  tail(.args, 1), p,
  ncol = plot.dt[, length(unique(tau))], nrow = 1,
  base_height = 3.5, base_width = 4
)

suppressPackageStartupMessages({
  require(denvax); require(data.table); require(jsonlite)
})

#' expected to be called with at least two arguments
#' first: json file(s) with model parameters
#' last: target rds file name to store synthesized pop digests
#' command line invocation from the published usage gives:
#' .args <- c(
#'   "results/fit-morrison2010.json",
#'   "results/fit-lazou2016.json",
#'   "results/ranges.rds"
#' )
.args <- commandArgs(trailingOnly = T)

jsonfiles <- head(.args, -1); outputfile <- tail(.args, 1)

allpars <- data.table::rbindlist( # bind together all the results from ...
  lapply(
    jsonfiles,           # for all the json files
    jsonlite::read_json, # read them in
    simplifyVector = T   # using the read_json simplification scheme
  )
)

survp <- function(f, A) (1 - f) ^ A
failp <- function(f, A) 1 - survp(f, A)

allpars[, seropos9 := p_H * failp(f_H, 9) + (1 - p_H) * failp(f_L, 9) ]
allpars[, seroneg9 := 1 - seropos9 ]
allpars[, OR9 := (
  failp(f_H, 9) * survp(f_L, 9)
) / (
  failp(f_L, 9) * survp(f_H, 9)
) ]

scan_labels <- c("ll", "md", "ul")

serorange <- allpars[, {
  ll <- min(floor(seropos9 * 10)) / 10
  ul <- max(ceiling(seropos9 * 10)) / 10
  .(seroneg9 = 1 - seq(ll, ul, length.out = 3), foi = scan_labels)
} ]

disprange <- allpars[, {
  llfrac <- min(floor(p_H * 10) / 10)
  ulfrac <- max(ceiling(p_H * 10) / 10)
  llOR <- min(floor(log10(OR9)))
  ulOR <- max(ceiling(log10(OR9)))
  .(
    p_H = seq(llfrac, ulfrac, length.out = 3),
    log10OR = seq(ulOR, llOR, length.out = 3),
    # note the opposite direction here - corresponds to observed pattern in data
    disparity = scan_labels
  )
}]

result <- serorange[, as.data.table(disprange), by = .(seroneg9, foi)]
foicalc <- function(seroneg9, log10OR9, p_H) {
  OR9 <- 10 ^ log10OR9
  A <- -(1 - OR9) * (1 - p_H)
  B <- (1 - OR9) * (seroneg9 - p_H) - OR9
  C <- OR9 * seroneg9
  slA <- -(B + sqrt(B ^ 2 - 4 * A * C)) / (2 * A)
  f_L <- 1 - slA ^ (1 / 9)
  shA <- pmax( (seroneg9 - (1 - p_H) * slA) / p_H, 0)
  f_H <- 1 - shA ^ (1 / 9)
  list(f_L = f_L, f_H = f_H)
}

result[, c("f_L", "f_H") := foicalc(seroneg9, log10OR, p_H)]

saveRDS(result, file = outputfile)

require(denvax)
require(jsonlite)
require(data.table)

# expected to be called with two arguments
# first: csv with sero data
# second: target json file to store fit data
.args <- commandArgs(trailingOnly = T)

# this example assumes csv has headers Seropositve, Number, and Age (among any others)
# and that Age is either a year (like the Morrison 2010 data), or a range (like the L'Azou 2016 data)
serodata <- data.table::fread(.args[1])
if (class(serodata$Age) == "integer") {
  serodata[, lower := Age ]
  serodata[, upper := Age ]
} else {
  serodata[, lower := as.integer(gsub("(\\d+)-.+", "\\1", Age)) ]
  serodata[, upper := as.integer(gsub(".+-(\\d+)", "\\1", Age)) ]
}

# this  assumes that all of the data is grouped by Country (like Morrison 2010 and L'Azou 2016),
# rather than some other grouping
# if there are different headers, or no headers, substitute the correct columns into
# denvax::serofit invocation, by= group specification
result <- serodata[,
  denvax::serofit(Seropositive, Number, lower, upper),
  by = Country
]

cat(
  jsonlite::prettify(jsonlite::toJSON(result, auto_unbox = T)),
  file = tail(.args, 1)
)

suppressPackageStartupMessages({
  require(ggplot2)
})

.args <- commandArgs(trailingOnly = T)

scale_start_age <- scale_x_continuous(
  "Initial Age for Routine Testing",
  expand = expand_scale(add = 0.1)
)

scale_end_age   <- scale_y_continuous(
  "Maximum Age for Testing",
  expand = expand_scale(add = 0.1)
)

scale_num_tests   <- scale_y_continuous(
  "Maximum # of Tests",
  breaks = function(lims) seq(round(lims[1]), round(lims[2]), by = 1),
  expand = expand_scale(add = 0.1)
)

scale_tau <- scale_x_continuous(
  expression(tau * ", Test Cost Fraction (log scale)"),
  labels = function(b) sprintf("%0.2f", 10 ^ b)
)

scale_nu <- scale_y_continuous(
  expression(nu * ", Vaccine Cost Fraction"),
  labels = function(b) sprintf("%0.1f", b)
)

scale_roi       <- scale_fill_gradient2(
  "ROI",
  limits = c(-1, 2), breaks = seq(-1, 2, by = 0.5),
  guide = guide_colorbar(order = 1)
)

pm <- function(f) sprintf("\U00B1%0.2f", f)

scale_contour <- list(
  scale_linetype_manual(
    breaks = c("zero", "c25", "c50"),
    labels = c(zero = "0.0", c25 = pm(0.25), c50 = pm(0.5)),
    values = c(zero = "solid", c25 = "dashed", c50 = "dotted"),
    guide = guide_legend(
      title = NULL,
      override.aes = list(color = rep("black", 3)),
      order = 5
    )
  ),
  scale_color_manual(
    values = c(zero = "black", pos = "dodgerblue", neg = "firebrick"),
    guide = "none"
  ),
  scale_alpha_manual(
    values = c(zero = 0.5, c25 = 0.5, c50 = 1),
    guide = "none"
  )
)

thm <- theme_minimal()

geom_heat <- list(
  geom_tile(aes(color = NULL)),
  geom_contour(
    aes(linetype = "zero", color = "zero", alpha = "zero"),
    breaks = 0
  ),
  geom_contour(
    aes(linetype = "c25", alpha = "c25"),
    breaks = c(-0.25, 0.25)
  ),
  geom_contour(
    aes(linetype = "c50", alpha = "c50"),
    breaks = c(-0.5, 0.5)
  )
)

save(list = ls(), file = tail(.args, 1))

suppressPackageStartupMessages({
  require(denvax); require(data.table)
})

.args <- c("results/scan-params.rds", "results/scan-rois.rds")
.args <- commandArgs(trailingOnly = T)

parcombns  <- readRDS(.args[1])
outputfile   <- tail(.args, 1)

props <- parcombns[,
  nPxA(synthetic.pop(.BY, rngseed = 5)),
  by = .(p_H, f_L, f_H, foi, disparity)
]

rcs <- props[,
  denvax::ROIcoeffs(.SD),
  by = .(foi, disparity)
]

# using those coefficients and the proposed cost fractions
# compute the ROI surfaces
rois <- rcs[,
  denvax::ROI(.SD), by = .(foi, disparity)
]

saveRDS(rois, file = tail(.args, 1))

require(denvax)
require(data.table)

# expected to be called with two arguments
# first: an rds containing a matrix. each row should correspond to a life history
#  columns correspond to a year in life.
#
# second: target rds file to store synthesized populations
.args <- commandArgs(trailingOnly = T)

# load the lifehistory
lifehistories <- readRDS(.args[1])

# compute the proportion coefficients
probs <- denvax::nPxA(lifehistories)

saveRDS(probs, file = tail(.args, 1))

# start to finish analysis

require(data.table)
require(denvax)
require(ggplot2)
require(cowplot)

.args <- c("inputs/serodata-morrison2010.csv", "results/ROI-morrison.png")
# your source serodata, in this example the Morrison 2010 data set
# and the plot target
.args <- commandArgs(trailingOnly = T) # or use from the command line

# read in the data
serodata <- fread(.args[1])

# fit the data
fit <- with(serodata, serofit(sero = Seropositive, N = Number, age.min = Age))

# simulate life histories
lh <- synthetic.pop(fit)

# estimate population probabilites for various life trajectories
probs <- nPxA(lh)

# compute the ROI equation coefficients
rc <- ROIcoeffs(probs, Ls = 10)

# use those coefficients to determine ROI surfaces
res <- ROI(rc,
  nus = seq(0.3, 0.9, by = 0.3),
  taus = 10 ^ seq(-1.5, -.5, by = .5)
)

# visualize results
p <- ggplot(res[L %in% c(1, 5, 10)]) +
  aes(
    x = A, y = roi,
    linetype = mechanism, alpha = factor(L),
    group = interaction(mechanism, L)
  ) +
  facet_grid(nu ~ tau, labeller = labeller(
    nu = function(nu) {
      paste0(c("\n", "\u03BD = \n", "\n"), sprintf("%.2g", as.numeric(nu)))
    },
    tau = function(tau) {
      paste0(c("\n", "\u03C4 = \n", "\n"), sprintf("%.2g", as.numeric(tau)))
    }
  )) +
  geom_line() + theme_minimal() +
  scale_y_continuous("ROI") +
  scale_x_continuous("Initial Testing Age") +
  scale_alpha_discrete("Max. # of Tests", breaks = c(1, 5, 10)) +
  scale_linetype_discrete("Vaccine Mechanism") +
  coord_cartesian(ylim = c(-1, 2))

save_plot(tail(.args, 1), p, ncol = 3, nrow = 3)

suppressPackageStartupMessages({
  require(denvax); require(data.table); require(jsonlite)
})

#' expected to be called with three arguments
#' first: reference rds with digested life history proportions
#' second: json file with
#'   (1) keys for each of the countries to compare
#'   (2) that point to objects with costs for
#'   secondary infection (S), testing (T), a vaccination (V)
#' last: target rds file name to store resulting ROIs
#' command line invocation from the published usage gives:
#' @example
#' .args <- c(
#'   "results/proportions.rds",
#'   "pub/malaysia_v_peru.json",
#'   "results/example-rois.rds"
#' )
.args <- commandArgs(trailingOnly = T)

proportions  <- readRDS(.args[1])
tarCountries <- jsonlite::read_json(.args[2])
outputfile   <- tail(.args, 1)

pars <- lapply(
  tarCountries,        # change the input parameters...
  function(pars) list( # into their dimensionless versions
    nu =  pars$V / pars$S,
    tau = pars$T / pars$S
  )
)

rcs <- proportions[
  Country %in% names(pars), # for only the countries of interest...
  denvax::ROIcoeffs(.SD),   # compute the ROI surface coefficients
  by = Country                # n.b., this uses the default age, test limits
]

# using those coefficients and the proposed cost fractions
# compute the ROI surfaces
rois <- rcs[,
  denvax::ROI(.SD,
    nus  = pars[[Country[1]]]$nu,
    taus = pars[[Country[1]]]$tau
  ), by = Country
]

saveRDS(rois, file = tail(.args, 1))

suppressPackageStartupMessages({
  require(data.table)
  require(jsonlite)
  require(ggplot2)
  require(cowplot)
})

#' @example
#' .args <- c("results/fig-scales.rda", "results/scan-rois.rds", "results/scan-params.rds", "results/fig-scan.png")
.args <- commandArgs(trailingOnly = T)

load(.args[1])

refpars <- readRDS(.args[3])[, seropos := 1 - seroneg9 ]

reducedrois <- readRDS(.args[2])[mechanism == "binary"][
  refpars, on = .(foi, disparity)
][, .(roi = max(roi)),
  by = .(foi, disparity, seropos, p_H, log10OR, nu, tau)
]

rename <- function(res, ref) { names(res) <- ref; return(res) }

foiref <- refpars[, seropos[1], by = .(ref = foi)][, rename(V1, ref)]
pHref <- refpars[, p_H[1], by = .(ref = disparity)][, rename(V1, ref)]
ORref <- refpars[, log10OR[1], by = .(ref = disparity)][, rename(V1, ref)]

disref <- list(
  md = quote(Disparity ~ (p[H] * ", " * log[10] * OR)),
  ll = quote(phantom("Disparity" ~ (p[H] * ", " * log[10] * OR))),
  ul = quote(phantom("Disparity" ~ (p[H] * ", " * log[10] * OR)))
)

p <- ggplot(reducedrois) + aes(
  log10(tau), nu,
  fill = roi, z = roi, color = c("neg", "pos")[(roi > 0) + 1]
) +
  facet_grid(
    disparity ~ foi,
    labeller = label_bquote(
      cols = .(
        sprintf("%s\n%d%%",
          ifelse(foi == "md", "% Seropositive 9-year-olds", ""),
          foiref[foi] * 100)
      ),
      rows = atop(
        .(
          disref[[disparity]]),
          (.(pHref[disparity]) * ", " * .(ORref[disparity]))
        )
    ), scales = "free"
  ) +
  geom_heat +
  thm + scale_contour + scale_roi + scale_nu + scale_tau

save_plot(tail(.args, 1), p, ncol = 3, nrow = 3, base_height = 4 * 2 / 3)

suppressPackageStartupMessages({
  require(denvax); require(data.table); require(jsonlite)
})

#' expected to be called with at least two arguments
#' first: json file(s) with model parameters
#' last: target rds file name to store synthesized pop digests
#' command line invocation from the published usage gives:
#' @example
#' .args <- c(
#'   "results/fit-morrison2010.json",
#'   "results/fit-lazou2016.json",
#'   "results/proportions.rds"
#' )
.args <- commandArgs(trailingOnly = T)

jsonfiles <- head(.args, -1); outputfile <- tail(.args, 1)

allpars <- data.table::rbindlist( # bind together all the results from ...
  lapply(
    jsonfiles,           # for all the json files
    jsonlite::read_json, # read them in
    simplifyVector = T   # using the read_json simplification scheme
  )
)

# then for all the parameter combinations
# generate the same synthetic population (rngseed = 1)
# and determine the life history proportions
results <- allpars[,
  denvax::nPxA(denvax::synthetic.pop(.SD, rngseed = 1)),
  by = Country
]
# this will take a bit to run...

saveRDS(results, file = outputfile)

require(denvax)
require(jsonlite)

# expected to be called with two arguments
# first: json with model parameters
# second: target rds file to store synthesized populations
.args <- commandArgs(trailingOnly = T)

# load the model parameters; considers first entry in json by default
if (length(.args) > 2) {
  tar <- as.integer(.args[2])
} else {
  tar <- 1L
}
pars <- as.list(
  jsonlite::read_json(.args[1], simplifyVector = T)[tar, c("f_H", "f_L", "p_H")]
)

# create a population with the sample defaults
warning("creating synthetic population; this will take some time to complete.")
results <- denvax::synthetic.pop(pars)

saveRDS(results, file = tail(.args, 1))

suppressPackageStartupMessages({
  require(data.table)
  require(jsonlite)
  require(ggplot2)
})

#' @example
#' .args <- c("results/fig-scales.rda", "results/example-rois.rds", "pub/malaysia_v_peru.json", "results/fig-compare.png")
.args <- commandArgs(trailingOnly = T)

load(.args[1])
rois <- readRDS(.args[2])
refnutau <- jsonlite::read_json(.args[3])

pars <- lapply(
  refnutau,        # change the input parameters...
  function(pars) list( # into their dimensionless versions
    nu  =  pars$V / pars$S,
    tau = pars$T / pars$S
  )
)

# X=\U1D708
# Y=\U1D70F

country_labels <- sprintf("%s: \U1D708 = %0.2f, Y = %0.2f",
  names(pars), c(pars[[1]]$nu, pars[[2]]$nu), c(pars[[1]]$tau, pars[[2]]$tau)
)
names(country_labels) <- names(pars)

rois[, lbl := sprintf(
  "'%s: '*nu*' = %0.2f, '*tau*' = %0.2f'", Country, nu, tau
)]

p <- ggplot(rois) +
  aes(
    x = A, y = A + L - 1,
    fill = roi, z = roi, color = c("neg", "pos")[(roi > 0) + 1]
  ) +
  facet_grid(mechanism ~ lbl, labeller = labeller(
    mechanism = c(ordinal = "Ordinal Test", binary = "Binary Test"),
    lbl   = label_parsed
  )) +
  geom_heat +
  thm + scale_contour + scale_roi + scale_start_age + scale_end_age

ggsave(tail(.args, 1), p, width = 6, height = 5, dpi = 600)

---
title: "Published Test-then-Vaccinate ROI Analyses"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{published-analysis}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

We computed the analysis in [this publication](https://doi.org/10.1098/rsif.2019.0234) in a series of steps, each dependent on the next, linked together via the traditional development tool [`gnu make`](https://www.gnu.org/software/make/manual/html_node/index.html).  We fit some example serological data sets (Morrison 2010 and L'Azou 2016, both collected from published studies and available as part of this package),
and then use those fits to simulate populations.

All of the scripts mentioned in this vignette are included in the `inst/extdata` of this package, and can be located wherever your R packages are installed, or accessed via the `build.project` tool to make a skeleton, or by using `list.files(system.file("extdata/pub", package="denvax"), pattern=".R", full.names = T)` to get the paths.

The skeleton includes a 'Makefile' that defines a general set of dependencies, as well as the specific steps used to generate the figures in the published manuscript.  The `simple.R` script demonstrates a simple start-to-finish analysis (using the Morrison 2010 data included in the package).

In either approach, the steps are:

1. develop fit(s) for local serological data (e.g., use the `fit.R` script from `build.project` in Rstudio, write your own script with the `denvax::serofit` function, or use make with the target `%-fit.json` in Makefile).
2. use a fit to synthesize a population (e.g., `synthesize.R` script, the `denvax::synthetic.pop` function, or the target `%-lh.rds` in Makefile)
3. use the synthetic population to estimate the lifetime outcome probabilities (e.g., `digest.R` script, the `denvax::npxa` function, or the target `%-npxa.rds` in Makefile)
4. combine the probabilities with the desired boundaries for interventions (initial testing age and maximum number of tests) and to compute the ROI equation coefficients (`denvax::ROIcoeffs` function)
5. finally, combine the coefficients with desired cost fraction ranges (i.e., the cost of vaccination and testing as fractions of the estimated burden of secondary infection, or $\nu$ and $\tau$ respectively), to determine the threshold region for positive ROI (`denvax::ROI` function).

Within the `pub/` directory, we have another makefile and scripts which cover the specific analyses used in the publication.
